/* Copyright (c) 2009 ActiveState Software Inc.
   See the file LICENSE.txt for licensing information. */

const CLASS_ID = Components.ID('{9bd9eb85-f919-48b9-a43e-c9792373ccc8}');
const CLASS_NAME = 'Komodo DBX Explorer JS Relative Date Converter';
const CONTRACT_ID = '@activestate.com/KoDBX_JS_RelativeDateConverter;1';
const CATEGORY_NAME = 'komodo-DBX-DataConverters';

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;

function DBXRelativeJSDate() {
}

DBXRelativeJSDate.prototype = {
    'label': 'as relative JS date',
    
    'supportedType':'integer',
    
    'convert': function(rawValue) {
        if (rawValue.length == 0) return "";
        var nowTime = (new Date()).valueOf();
        var laterTime = new Date(nowTime + parseInt(rawValue));
        return laterTime.toString();
    },

    QueryInterface: function(iid) {
        if(!iid.equals(Ci.koIDBXCellDataConverter) &&
           !iid.equals(Ci.nsISupports))
            throw Cr.NS_ERROR_NO_INTERFACE;
        return this;
    }
};

var DBXRelativeJSDateFactory = {
    createInstance: function(aOuter, iid) {
        if(aOuter != null)
            throw Cr.NS_ERROR_NO_AGGREGATION;
        return (new DBXRelativeJSDate()).QueryInterface(iid);
    }
};

var DBXRelativeJSDateModule = {
    registerSelf: function(compMgr, fileSpec, location, type) {
        compMgr = compMgr.QueryInterface(Ci.nsIComponentRegistrar);
        dump("Registering '" + CONTRACT_ID + "' (relativeJSDateConverter.js)\n");
        compMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME, CONTRACT_ID, fileSpec, location, type);
        var catMan = Cc['@mozilla.org/categorymanager;1'].
            getService(Ci.nsICategoryManager);
        catMan.addCategoryEntry(CATEGORY_NAME, CONTRACT_ID, "", true, true);
    },

    unregisterSelf: function(compMgr, fileSpec, location) {        
        compMgr = compMgr.QueryInterface(Ci.nsIComponentRegistrar);
        compMgr.unregisterFactoryLocation(CLASS_ID, location);
        var catMan = Cc['@mozilla.org/categorymanager;1'].
            getService(Ci.nsICategoryManager);
        catMan.deleteCategoryEntry(CATEGORY_NAME, CONTRACT_ID, true);
    },

    getClassObject: function(compMgr, cid, iid) {
        if (!iid.equals(Ci.nsIFactory))
            throw NS_ERROR_NOT_IMPLEMENTED;
        if (cid.equals(CLASS_ID))
            return DBXRelativeJSDateFactory;
        throw NS_ERROR_NO_INTERFACE;
    },

    canUnload: function(compMgr) {
        return true;
    }
};

function NSGetModule(compMgr, fileSpec) {
    return DBXRelativeJSDateModule;
}
